/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// Button state class

#include "button.h"

Button::Button(void) : pressed(false), repeat(500), last_pressed(0)
{
}


// Returns true if button is pressed
bool Button::IsPressed(void) const
{
    return pressed;
}

// Button up event received
void Button::Up(void)
{
    pressed = false;
    repeat = 500;
}

// Button down event received
void Button::Down(void)
{
    last_pressed = SDL_GetTicks();
    if (pressed) repeat = 10;
    pressed = true;
}

// Returns true is the button repeat timer has expired
bool Button::Repeat(void) const
{
    return ((SDL_GetTicks() - last_pressed) > repeat);
}
