/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef BUTTON_H
#define BUTTON_H

#include <SDL.h>

// Button state class

class Button
{
public:
    Button(void);

    // Returns true if button is pressed
    bool IsPressed(void) const;

    // Up event received
    void Up(void);

    // Down event received
    void Down(void);

    // Returns true if time to check for repeat
    bool Repeat(void) const;

private:
    // Pressed state
    bool pressed;

    // Repeat interval in millisecs
    int repeat;

    // Time of last press/release
    Uint32 last_pressed;
};

#endif // BUTTON_H
