/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************//***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "font.h"
#include <fstream>
#include <iostream>

using namespace std;

// Font class

// Load font from file - currently raw 96 characters of 8 bytes 
Font::Font(std::string fn)
{
    ifstream ff(fn.c_str());
    if (ff.good())
    {
	ff.read(reinterpret_cast<char*>(font), sizeof(font));
    }
}


// Put string at x,y on screen
void Font::PutString(Screen &dest, int x, int y, 
		     const Colour& fg, const Colour& bg, std::string s)
{
    /* Truncate string to fit dest */

    int l = s.length();
    if (x+(l*8) > dest.get_width())
    {
	s.resize((dest.get_width() - x)/8);
    }

    for (int i=0; i<l; i++)
    {
	PutChar(dest, x+i*8, y, fg, bg, s[i]);
    }	
}

// Put character at x,y on screen
void Font::PutChar(Screen& dest, int x, int y, 
		   const Colour& fg, const Colour& bg, int c)
{
    if (c >= ' ' && c < 128)
    {
	c -= ' ';
	for (int i=0; i<8; i++)
	{
	    int k = font[c][i];
	    for (int j=0;j<8;j++)
	    {
		Colour col(bg);
		if (k&(0x80>>j))
		{
		    
		    col = fg;
		}
		dest.PutPixel(x+j, y+i, col);
	    }
	}
    }
}
