/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FONT_H
#define FONT_H

#include <string>
#include <SDL.h>
#include "screen.h"
#include "colour.h"

// Font class - font is raw data 96 characters of 8 bytes
class Font
{
public:
    // Load font file
    Font(std::string fn);

    // Put character at x,y on screen specifying colours
    void PutChar(Screen& dest, int x, int y, 
		 const Colour& fg, const Colour& bg, int c);

    // Put string at x,y on screen specifying colours
    void PutString(Screen& dest, int x, int y, 
		   const Colour& fg, const Colour& bg, std::string s);
private:
    // Font data
    char font[96][8];   
};

#endif // FONT_H
