/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef IMPL_H
#define IMPL_H
#include <string>
#include "screen.h"
#include "input.h"

// Class Impl - provides the interface for the application
class Impl
{
public:
    
    // Application initialisation
    virtual void Initialise(Screen& s) = 0;

    // Rendering operation
    virtual void Render(Screen& s) = 0;

    // Other processing
    virtual void NonRender(const Input& input) = 0;

    // Notification of button state change
    virtual void ButtonChange(const Input& input, Input::ButtonType b) = 0;
};
#endif //IMPL_H

