/***************************************************************************
 *   Copyright (C) 2006 by Dave Parker                                     *
 *   drparker@freenet.co.uk                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SCREEN_H
#define SCREEN_H
#include <string>
#include <SDL.h>

class Colour;

// Screen class
class Screen
{

public:
    // Construct 16 bit colour screen of given size
    Screen (int w, int h);
        
    // Draw a rectangle
    void Rect (int x, int y, int w, int h, const Colour& c);
        
    void PutPixel(int x, int y, const Colour& c);

    // Lock screen
    void  Lock(void);
        
    // Unlock screen
    void  Unlock(void);
        
    // Update whole screen
    void  Update(void);
        
    

private:
    //Screen surface
     SDL_Surface* screen;

     // Size
     int width;
     int height;

public:
    // Accessor Methods
    SDL_Surface* get_screen(void) const;
    int get_width(void) const;
    int get_height(void) const;

    // Return pixel format
    SDL_PixelFormat* Format(void) const; 
};
#endif //SCREEN_H

